#include "HID-Project.h"

unsigned long t0;
bool readflag;
unsigned long delaytime;
KeyboardKeycode key1;
KeyboardKeycode key2;
KeyboardKeycode key3;
KeyboardKeycode key4;
KeyboardKeycode key5;
KeyboardKeycode key6;
byte modifierkey;
byte mx;
byte my;
byte mw;
byte mbutton;


void setup() {
  delay(1000); //wait for re-programming
  BootKeyboard.begin();
  //Mouse.begin();
  Serial1.begin(9600);

  t0 = millis();
  readflag = true;
  delaytime = 24;
}


void loop() {
  unsigned long ms;
  ms = millis();
  if (ms - t0 >= delaytime) readflag = true;
  if (readflag && Serial1.available() >= 12) {
    //read
    delaytime = Serial1.read(); //delaytime
    key1 = (KeyboardKeycode)Serial1.read(); //pressed key 1
    key2 = (KeyboardKeycode)Serial1.read(); //pressed key 2
    key3 = (KeyboardKeycode)Serial1.read(); //pressed key 3
    key4 = (KeyboardKeycode)Serial1.read(); //pressed key 4
    key5 = (KeyboardKeycode)Serial1.read(); //pressed key 5
    key6 = (KeyboardKeycode)Serial1.read(); //pressed key 6
    modifierkey = Serial1.read(); //modifier key
    mbutton = Serial1.read(); //mouse button
    mx = Serial1.read(); //mouse x
    my = Serial1.read(); //mouse y
    mw = Serial1.read(); //mouse w
    Serial1.write(delaytime);
    readflag = 0;
    t0 = ms;
  }

  BootKeyboard.removeAll();
  BootKeyboard.add(key1);
  BootKeyboard.add(key2);
  BootKeyboard.add(key3);
  BootKeyboard.add(key4);
  BootKeyboard.add(key5);
  BootKeyboard.add(key6);
  if (modifierkey & 0x1) BootKeyboard.add((KeyboardKeycode)0xE3); //Left Win
  if (modifierkey & 0x2) BootKeyboard.add((KeyboardKeycode)0xE1); //Left Shift
  if (modifierkey & 0x4) BootKeyboard.add((KeyboardKeycode)0xE0); //Left Ctrl
  if (modifierkey & 0x8) BootKeyboard.add((KeyboardKeycode)0xE2); //Left Alt
  //Mouse.setButtons(mbutton);
  //Mouse.move(mx, my, mw);
  BootKeyboard.send();
}
